Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/Common/UpdateControl.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/Common/UpdateControl.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Views/Common/UpdateControl.cs	(revision 6743)
@@ -40,6 +40,8 @@
       if (imgBoxProgress.InvokeRequired) {
         imgBoxProgress.Invoke(new MethodInvoker(() => imgBoxProgress.Visible = false));
+        btnRefresh.Invoke(new MethodInvoker(() => btnRefresh.Enabled = true));
       } else {
         imgBoxProgress.Visible = false;
+        btnRefresh.Enabled = true;
       }
     }
@@ -49,6 +51,8 @@
         if (imgBoxProgress.InvokeRequired) {
           imgBoxProgress.Invoke(new MethodInvoker(() => imgBoxProgress.Visible = true));
+          btnRefresh.Invoke(new MethodInvoker(() => btnRefresh.Enabled = false));
         } else {
           imgBoxProgress.Visible = true;
+          btnRefresh.Enabled = false;
         }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.3/Views/RefreshableHiveExperimentView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.3/Views/RefreshableHiveExperimentView.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.3/Views/RefreshableHiveExperimentView.cs	(revision 6743)
@@ -93,12 +93,12 @@
 
     private void RegisterHiveJobEvents() {
-      Content.HiveJobs.ItemsAdded += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
-      Content.HiveJobs.ItemsRemoved += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
-      Content.HiveJobs.CollectionReset += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.ItemsAdded += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.ItemsRemoved += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.CollectionReset += new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
     }
     private void DeregisterHiveJobEvents() {
-      Content.HiveJobs.ItemsAdded -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
-      Content.HiveJobs.ItemsRemoved -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
-      Content.HiveJobs.CollectionReset -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.ItemsAdded -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.ItemsRemoved -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
+      Content.HiveTasks.CollectionReset -= new CollectionItemsChangedEventHandler<HiveTask>(HiveJobs_ItemsAdded_Removed_Reset);
     }
 
@@ -140,5 +140,5 @@
       if (Content != null) {
         bool alreadyUploaded = Content.Id != Guid.Empty;
-        bool jobsLoaded = Content.HiveJobs != null && Content.HiveJobs.All(x => x.Task.Id != Guid.Empty);
+        bool jobsLoaded = Content.HiveTasks != null && Content.HiveTasks.All(x => x.Task.Id != Guid.Empty);
 
         this.nameTextBox.ReadOnly = !Content.IsControllable || Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded;
@@ -229,6 +229,6 @@
         Invoke(new EventHandler(Content_HiveJobChanged), sender, e);
       else {
-        if (Content != null && Content.HiveJobs != null) {
-          jobsTreeView.Content = Content.HiveJobs;
+        if (Content != null && Content.HiveTasks != null) {
+          jobsTreeView.Content = Content.HiveTasks;
           RegisterHiveJobEvents();
         } else {
@@ -297,11 +297,11 @@
     #region Control events
     private void startButton_Click(object sender, EventArgs e) {
-      HiveClient.StartExperiment((Exception ex) => ErrorHandling.ShowErrorDialog(this, "Start failed.", ex), Content, new CancellationToken());
+      HiveClient.StartJob((Exception ex) => ErrorHandling.ShowErrorDialog(this, "Start failed.", ex), Content, new CancellationToken());
     }
     private void pauseButton_Click(object sender, EventArgs e) {
-      HiveClient.PauseExperiment(Content);
+      HiveClient.PauseJob(Content);
     }
     private void stopButton_Click(object sender, EventArgs e) {
-      HiveClient.StopExperiment(Content);
+      HiveClient.StopJob(Content);
     }
     private void resetButton_Click(object sender, EventArgs e) { }
@@ -326,5 +326,5 @@
 
     private void refreshButton_Click(object sender, EventArgs e) {
-      var invoker = new Action<RefreshableJob>(HiveClient.LoadExperiment);
+      var invoker = new Action<RefreshableJob>(HiveClient.LoadJob);
       invoker.BeginInvoke(Content, (ar) => {
         try {
@@ -338,5 +338,5 @@
 
     private void refreshPermissionsButton_Click(object sender, EventArgs e) {
-      hiveExperimentPermissionListView.Content = HiveClient.GetHiveExperimentPermissions(this.Content.Job.Id);
+      hiveExperimentPermissionListView.Content = HiveClient.GetJobPermissions(this.Content.Job.Id);
     }
 
@@ -349,5 +349,5 @@
         startButton.Enabled = pauseButton.Enabled = stopButton.Enabled = resetButton.Enabled = false;
       } else {
-        startButton.Enabled = Content.IsControllable && Content.HiveJobs != null && Content.HiveJobs.Count > 0 && Content.ExecutionState == ExecutionState.Prepared;
+        startButton.Enabled = Content.IsControllable && Content.HiveTasks != null && Content.HiveTasks.Count > 0 && Content.ExecutionState == ExecutionState.Prepared;
         pauseButton.Enabled = Content.IsControllable && Content.ExecutionState == ExecutionState.Started;
         stopButton.Enabled = Content.IsControllable && Content.ExecutionState == ExecutionState.Started;
@@ -406,5 +406,5 @@
         var optimizer = obj as IOptimizer;
         if (optimizer != null) {
-          Content.HiveJobs.Add(new OptimizerHiveTask(e.Effect.HasFlag(DragDropEffects.Copy) ? (IOptimizer)optimizer.Clone() : optimizer));
+          Content.HiveTasks.Add(new OptimizerHiveTask(e.Effect.HasFlag(DragDropEffects.Copy) ? (IOptimizer)optimizer.Clone() : optimizer));
         }
       }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HiveSlaveApplication.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HiveSlaveApplication.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HiveSlaveApplication.cs	(revision 6743)
@@ -34,7 +34,6 @@
       coreThread.Start();
 
-      SlaveItem item = new SlaveItem();
       MainWindow window = new MainWindow();
-      window.SetContent(item);
+      window.Content = new SlaveItem();
       Application.Run(window);
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/MainWindow.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/MainWindow.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/MainWindow.cs	(revision 6743)
@@ -40,6 +40,9 @@
     }
 
-    public void SetContent(SlaveItem item) {
-      slaveMainView.Content = item;
+    public SlaveItem Content {
+      get { return slaveMainView.Content; }
+      set {
+        slaveMainView.Content = value;
+      }
     }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/JobsView.cs	(revision 6743)
@@ -59,12 +59,17 @@
     #region Event Handlers
     void Content_SlaveStatusChanged(object sender, Common.EventArgs<StatusCommons> e) {
-      lstJobs.Items.Clear();
-      foreach (TaskStatus job in e.Value.Jobs) {
-        ListViewItem item = new ListViewItem();
-        item.Text = job.TaskId.ToString();
-        item.SubItems.Add(job.ExecutionTime.ToString());
-        lstJobs.Items.Add(item);
+      if (InvokeRequired) {
+        Action<object, Common.EventArgs<StatusCommons>> action = new Action<object, Common.EventArgs<StatusCommons>>(Content_SlaveStatusChanged);
+        Invoke(action, sender, e);
+      } else {
+        lstJobs.Items.Clear();
+        foreach (TaskStatus job in e.Value.Jobs) {
+          ListViewItem item = new ListViewItem();
+          item.Text = job.TaskId.ToString();
+          item.SubItems.Add(job.ExecutionTime.ToString());
+          lstJobs.Items.Add(item);
+        }
+        lstJobs.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
       }
-      lstJobs.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
     }
     #endregion
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/LogView.cs	(revision 6743)
@@ -69,5 +69,9 @@
     #region Event Handlers
     void Content_SlaveMessageLogged(object sender, EventArgs<string> e) {
-      txtLog.AppendText(e.Value + Environment.NewLine);
+      if (txtLog.InvokeRequired) {
+        txtLog.Invoke(new Action<string>(txtLog.AppendText), e.Value + Environment.NewLine);
+      } else {
+        txtLog.AppendText(e.Value + Environment.NewLine);
+      }
     }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveCmdsWithKill.cs	(revision 6743)
@@ -65,6 +65,4 @@
     #region Register Content Events
     protected override void DeregisterContentEvents() {
-
-
       base.DeregisterContentEvents();
     }
@@ -173,5 +171,4 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      //do nothing at the moment, we have nothing editable
     }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveItem.cs	(revision 6743)
@@ -65,5 +65,5 @@
 
     void pipeFactory_Opened(object sender, EventArgs e) {
-      OnMessageLogged("Connection to Slave core established");
+      OnMessageLogged("Connection to Slave core opened");
       OnCoreConnectionChanged(CoreConnection.Connected);
     }
@@ -188,5 +188,4 @@
       var handler = SlaveDisplayStateChanged;
       if (handler != null) handler(this, new EventArgs<SlaveDisplayStat>(stat));
-
     }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveMainViewBase.cs	(revision 6743)
@@ -76,5 +76,4 @@
       if (Content != null) {
         Content.UserVisibleMessageFired += new System.EventHandler<Common.EventArgs<string>>(Content_UserVisibleMessageFired);
-        ((SlaveItem)base.Content).Open();
         Task.Factory.StartNew(Connector);
       }
@@ -106,7 +105,8 @@
 
     private void Connector() {
+      ((SlaveItem)base.Content).Open();
       bool connected = false;
       while (!connected) {
-        this.Invoke(new Func<bool>(() => connected = ((SlaveItem)base.Content).ReconnectToSlaveCore()));
+        connected = ((SlaveItem)base.Content).ReconnectToSlaveCore();
 
         if (!connected) {
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.3/SlaveStats.cs	(revision 6743)
@@ -35,5 +35,4 @@
     private SlaveDisplayStat lastSlaveDisplayStat;
 
-
     public new SlaveItem Content {
       get { return (SlaveItem)base.Content; }
@@ -56,5 +55,4 @@
       Content.SlaveStatusChanged -= new System.EventHandler<EventArgs<StatusCommons>>(Content_SlaveStatusChanged);
       Content.SlaveDisplayStateChanged -= new EventHandler<EventArgs<SlaveDisplayStat>>(Content_SlaveDisplayStateChanged);
-      Content.CoreConnectionChanged -= new EventHandler<EventArgs<CoreConnection>>(Content_CoreConnectionChanged);
 
       base.DeregisterContentEvents();
@@ -66,5 +64,4 @@
       Content.SlaveStatusChanged += new System.EventHandler<EventArgs<StatusCommons>>(Content_SlaveStatusChanged);
       Content.SlaveDisplayStateChanged += new EventHandler<EventArgs<SlaveDisplayStat>>(Content_SlaveDisplayStateChanged);
-      Content.CoreConnectionChanged += new EventHandler<EventArgs<CoreConnection>>(Content_CoreConnectionChanged);
     }
     #endregion
@@ -80,82 +77,96 @@
     #region Event Handlers
     void Content_SlaveStatusChanged(object sender, EventArgs<StatusCommons> e) {
-      RenderJobChart(e.Value);
-      RenderCoreChart(e.Value);
+      if (InvokeRequired) {
+        Action<object, EventArgs<StatusCommons>> action = new Action<object, EventArgs<StatusCommons>>(Content_SlaveStatusChanged);
+        Invoke(action, sender, e);
+      } else {
+        RenderJobChart(e.Value);
+        RenderCoreChart(e.Value);
+      }
     }
 
     void Content_SlaveDisplayStateChanged(object sender, EventArgs<SlaveDisplayStat> e) {
-      lblSlaveState.Text = e.Value.ToString();
-      lastSlaveDisplayStat = e.Value;
-    }
-
-    void Content_CoreConnectionChanged(object sender, EventArgs<CoreConnection> e) {
-
+      if (InvokeRequired) {
+        Action<object, EventArgs<SlaveDisplayStat>> action = new Action<object, EventArgs<SlaveDisplayStat>>(Content_SlaveDisplayStateChanged);
+        Invoke(action, sender, e);
+      } else {
+        lblSlaveState.Text = e.Value.ToString();
+        lastSlaveDisplayStat = e.Value;
+      }
     }
     #endregion
 
     private void RenderJobChart(StatusCommons status) {
-      jobChart.Series[0].Points.Clear();
-      jobChart.Series[1].Points.Clear();
-      jobChart.Series[2].Points.Clear();
-      jobChart.Series[3].Points.Clear();
-      jobChart.Series[4].Points.Clear();
+      if (InvokeRequired) {
+        Invoke(new Action<StatusCommons>(RenderJobChart), status);
+      } else {
+        jobChart.Series[0].Points.Clear();
+        jobChart.Series[1].Points.Clear();
+        jobChart.Series[2].Points.Clear();
+        jobChart.Series[3].Points.Clear();
+        jobChart.Series[4].Points.Clear();
 
 
-      DataPoint pJobs = new DataPoint(1, status.Jobs.Count);
-      DataPoint pJobsAborted = new DataPoint(2, status.JobsAborted);
-      DataPoint pJobsDone = new DataPoint(3, status.JobsFinished);
-      DataPoint pJobsFetched = new DataPoint(4, status.JobsFetched);
-      DataPoint pJobsFailed = new DataPoint(5, status.JobsFailed);
+        DataPoint pJobs = new DataPoint(1, status.Jobs.Count);
+        DataPoint pJobsAborted = new DataPoint(2, status.JobsAborted);
+        DataPoint pJobsDone = new DataPoint(3, status.JobsFinished);
+        DataPoint pJobsFetched = new DataPoint(4, status.JobsFetched);
+        DataPoint pJobsFailed = new DataPoint(5, status.JobsFailed);
 
-      pJobs.LegendText = "Current jobs: " + status.Jobs.Count;
-      pJobs.Color = System.Drawing.Color.Yellow;
-      pJobs.ToolTip = pJobs.LegendText;
-      jobChart.Series[0].Color = System.Drawing.Color.Yellow;
-      jobChart.Series[0].LegendText = pJobs.LegendText;
-      jobChart.Series[0].Points.Add(pJobs);
+        pJobs.LegendText = "Current jobs: " + status.Jobs.Count;
+        pJobs.Color = System.Drawing.Color.Yellow;
+        pJobs.ToolTip = pJobs.LegendText;
+        jobChart.Series[0].Color = System.Drawing.Color.Yellow;
+        jobChart.Series[0].LegendText = pJobs.LegendText;
+        jobChart.Series[0].Points.Add(pJobs);
 
-      pJobsAborted.LegendText = "Aborted jobs: " + status.JobsAborted;
-      pJobsAborted.Color = System.Drawing.Color.Orange;
-      pJobsAborted.ToolTip = pJobsAborted.LegendText;
-      jobChart.Series[1].Color = System.Drawing.Color.Orange;
-      jobChart.Series[1].LegendText = pJobsAborted.LegendText;
-      jobChart.Series[1].Points.Add(pJobsAborted);
+        pJobsAborted.LegendText = "Aborted jobs: " + status.JobsAborted;
+        pJobsAborted.Color = System.Drawing.Color.Orange;
+        pJobsAborted.ToolTip = pJobsAborted.LegendText;
+        jobChart.Series[1].Color = System.Drawing.Color.Orange;
+        jobChart.Series[1].LegendText = pJobsAborted.LegendText;
+        jobChart.Series[1].Points.Add(pJobsAborted);
 
-      pJobsDone.LegendText = "Finished jobs: " + status.JobsFinished;
-      pJobsDone.Color = System.Drawing.Color.Green;
-      pJobsDone.ToolTip = pJobsDone.LegendText;
-      jobChart.Series[2].Color = System.Drawing.Color.Green;
-      jobChart.Series[2].LegendText = pJobsDone.LegendText;
-      jobChart.Series[2].Points.Add(pJobsDone);
+        pJobsDone.LegendText = "Finished jobs: " + status.JobsFinished;
+        pJobsDone.Color = System.Drawing.Color.Green;
+        pJobsDone.ToolTip = pJobsDone.LegendText;
+        jobChart.Series[2].Color = System.Drawing.Color.Green;
+        jobChart.Series[2].LegendText = pJobsDone.LegendText;
+        jobChart.Series[2].Points.Add(pJobsDone);
 
-      pJobsFetched.LegendText = "Fetched jobs: " + status.JobsFetched;
-      pJobsFetched.ToolTip = pJobsFetched.LegendText;
-      pJobsFetched.Color = System.Drawing.Color.Blue;
-      jobChart.Series[3].Color = System.Drawing.Color.Blue;
-      jobChart.Series[3].LegendText = pJobsFetched.LegendText;
-      jobChart.Series[3].Points.Add(pJobsFetched);
+        pJobsFetched.LegendText = "Fetched jobs: " + status.JobsFetched;
+        pJobsFetched.ToolTip = pJobsFetched.LegendText;
+        pJobsFetched.Color = System.Drawing.Color.Blue;
+        jobChart.Series[3].Color = System.Drawing.Color.Blue;
+        jobChart.Series[3].LegendText = pJobsFetched.LegendText;
+        jobChart.Series[3].Points.Add(pJobsFetched);
 
-      pJobsFailed.LegendText = "Failed jobs: " + status.JobsFailed;
-      pJobsFailed.ToolTip = pJobsFailed.LegendText;
-      pJobsFailed.Color = System.Drawing.Color.Red;
-      jobChart.Series[4].Color = System.Drawing.Color.Red;
-      jobChart.Series[4].LegendText = pJobsFailed.LegendText;
-      jobChart.Series[4].Points.Add(pJobsFailed);
+        pJobsFailed.LegendText = "Failed jobs: " + status.JobsFailed;
+        pJobsFailed.ToolTip = pJobsFailed.LegendText;
+        pJobsFailed.Color = System.Drawing.Color.Red;
+        jobChart.Series[4].Color = System.Drawing.Color.Red;
+        jobChart.Series[4].LegendText = pJobsFailed.LegendText;
+        jobChart.Series[4].Points.Add(pJobsFailed);
+      }
     }
 
     private void RenderCoreChart(StatusCommons statusCommons) {
-      int usedCores = statusCommons.TotalCores - statusCommons.FreeCores;
-      DataPoint pFreeCores = new DataPoint(statusCommons.FreeCores, statusCommons.FreeCores);
-      DataPoint pUsedCores = new DataPoint(usedCores, usedCores);
+      if (InvokeRequired) {
+        Invoke(new Action<StatusCommons>(RenderCoreChart), statusCommons);
+      } else {
+        int usedCores = statusCommons.TotalCores - statusCommons.FreeCores;
+        DataPoint pFreeCores = new DataPoint(statusCommons.FreeCores, statusCommons.FreeCores);
+        DataPoint pUsedCores = new DataPoint(usedCores, usedCores);
 
-      coresChart.Series[0].Points.Clear();
+        coresChart.Series[0].Points.Clear();
 
-      pFreeCores.LegendText = "Free cores: " + statusCommons.FreeCores;
-      pFreeCores.Color = System.Drawing.Color.Green;
-      pUsedCores.LegendText = "Used cores: " + usedCores;
-      pUsedCores.Color = System.Drawing.Color.Red;
+        pFreeCores.LegendText = "Free cores: " + statusCommons.FreeCores;
+        pFreeCores.Color = System.Drawing.Color.Green;
+        pUsedCores.LegendText = "Used cores: " + usedCores;
+        pUsedCores.Color = System.Drawing.Color.Red;
 
-      coresChart.Series[0].Points.Add(pFreeCores);
-      coresChart.Series[0].Points.Add(pUsedCores);
+        coresChart.Series[0].Points.Add(pFreeCores);
+        coresChart.Series[0].Points.Add(pUsedCores);
+      }
     }
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 6743)
@@ -232,10 +232,10 @@
       int usedCores = 0;
       try {
-        task = wcfService.GetJob(taskId);
+        task = wcfService.GetTask(taskId);
         if (task == null) throw new TaskNotFoundException(taskId);
         if (ConfigManager.Instance.GetFreeCores() < task.CoresNeeded) throw new OutOfCoresException();
         if (ConfigManager.GetFreeMemory() < task.MemoryNeeded) throw new OutOfMemoryException();
         SlaveStatusInfo.IncrementUsedCores(task.CoresNeeded); usedCores = task.CoresNeeded;
-        TaskData taskData = wcfService.GetJobData(taskId);
+        TaskData taskData = wcfService.GetTaskData(taskId);
         if (taskData == null) throw new TaskDataNotFoundException(taskId);
         task = wcfService.UpdateJobState(taskId, TaskState.Calculating, null);
@@ -273,5 +273,5 @@
       Guid taskId = (Guid)taskIdObj;
       try {
-        Task task = wcfService.GetJob(taskId);
+        Task task = wcfService.GetTask(taskId);
         if (task == null) throw new TaskNotFoundException(taskId);
         taskManager.StopTaskAsync(taskId);
@@ -291,5 +291,5 @@
       Guid taskId = (Guid)taskIdObj;
       try {
-        Task task = wcfService.GetJob(taskId);
+        Task task = wcfService.GetTask(taskId);
         if (task == null) throw new TaskNotFoundException(taskId);
         taskManager.PauseTaskAsync(taskId);
@@ -334,9 +334,9 @@
         SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
         heartbeatManager.AwakeHeartBeatThread();
-        Task task = wcfService.GetJob(e.Value.TaskId);
+        Task task = wcfService.GetTask(e.Value.TaskId);
         if (task == null) throw new TaskNotFoundException(e.Value.TaskId);
         task.ExecutionTime = e.Value.ExecutionTime;
         TaskData taskData = e.Value.GetTaskData();
-        wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Paused);
+        wcfService.UpdateTaskData(task, taskData, configManager.GetClientInfo().Id, TaskState.Paused);
       }
       catch (TaskNotFoundException ex) {
@@ -352,9 +352,9 @@
         SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
         heartbeatManager.AwakeHeartBeatThread();
-        Task task = wcfService.GetJob(e.Value.TaskId);
+        Task task = wcfService.GetTask(e.Value.TaskId);
         if (task == null) throw new TaskNotFoundException(e.Value.TaskId);
         task.ExecutionTime = e.Value.ExecutionTime;
         TaskData taskData = e.Value.GetTaskData();
-        wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Finished);
+        wcfService.UpdateTaskData(task, taskData, configManager.GetClientInfo().Id, TaskState.Finished);
       }
       catch (TaskNotFoundException ex) {
@@ -374,9 +374,9 @@
         Exception exception = e.Value.Item3;
 
-        Task task = wcfService.GetJob(slaveTask.TaskId);
+        Task task = wcfService.GetTask(slaveTask.TaskId);
         if (task == null) throw new TaskNotFoundException(slaveTask.TaskId);
         task.ExecutionTime = slaveTask.ExecutionTime;
         if (taskData != null) {
-          wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Failed, exception.ToString());
+          wcfService.UpdateTaskData(task, taskData, configManager.GetClientInfo().Id, TaskState.Failed, exception.ToString());
         } else {
           wcfService.UpdateJobState(task.Id, TaskState.Failed, exception.ToString());
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 6743)
@@ -55,34 +55,34 @@
 
     #region Task Methods
-    public Task GetJob(Guid jobId) {
-      return CallHiveService(s => s.GetJob(jobId));
+    public Task GetTask(Guid taskId) {
+      return CallHiveService(s => s.GetTask(taskId));
     }
 
-    public void UpdateJob(Task job) {
-      CallHiveService(s => s.UpdateJob(job));
+    public void UpdateTask(Task task) {
+      CallHiveService(s => s.UpdateTask(task));
     }
     #endregion
 
     #region TaskData Methods
-    public TaskData GetJobData(Guid jobId) {
-      return CallHiveService(s => s.GetJobData(jobId));
+    public TaskData GetTaskData(Guid taskId) {
+      return CallHiveService(s => s.GetTaskData(taskId));
     }
 
     /// <summary>
-    /// Uploads the taskData and sets a new jobState (while correctly setting Transferring state)
+    /// Uploads the taskData and sets a new taskState (while correctly setting Transferring state)
     /// </summary>
-    public void UpdateJobData(Task job, TaskData jobData, Guid slaveId, TaskState state, string exception = "") {
+    public void UpdateTaskData(Task task, TaskData taskData, Guid slaveId, TaskState state, string exception = "") {
       CallHiveService(service => {
-        service.UpdateJob(job);
-        job = service.UpdateJobState(job.Id, TaskState.Transferring, slaveId, null, null);
+        service.UpdateTask(task);
+        task = service.UpdateTaskState(task.Id, TaskState.Transferring, slaveId, null, null);
         HiveClient.TryAndRepeat(() => {
-          service.UpdateJobData(job, jobData);
+          service.UpdateTaskData(task, taskData);
         }, Settings.Default.PluginDeletionRetries, "Could not upload jobdata.");
-        service.UpdateJobState(job.Id, state, slaveId, null, exception);
+        service.UpdateTaskState(task.Id, state, slaveId, null, exception);
       });
     }
 
-    public Task UpdateJobState(Guid jobId, TaskState jobState, string exception) {
-      return CallHiveService(s => s.UpdateJobState(jobId, jobState, ConfigManager.Instance.GetClientInfo().Id, null, exception));
+    public Task UpdateJobState(Guid taskId, TaskState taskState, string exception) {
+      return CallHiveService(s => s.UpdateTaskState(taskId, taskState, ConfigManager.Instance.GetClientInfo().Id, null, exception));
     }
     #endregion
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs	(revision 6743)
@@ -45,7 +45,7 @@
       var rhc = new RefreshableJob();
       var optimizer = CreateOptimizer();
-      rhc.HiveJobs.Add(new OptimizerHiveTask(optimizer));
+      rhc.HiveTasks.Add(new OptimizerHiveTask(optimizer));
       
-      HiveClient.StartExperiment((Exception ex) => TestContext.WriteLine(ex.ToString()), rhc, new CancellationToken());
+      HiveClient.StartJob((Exception ex) => TestContext.WriteLine(ex.ToString()), rhc, new CancellationToken());
 
       while (rhc.ExecutionState != Core.ExecutionState.Stopped) {
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 6743)
@@ -129,5 +129,5 @@
           this.dateFinishedTextBox.Text = Content.Task.DateFinished.ToString();
           this.exceptionTextBox.Text = Content.Task.CurrentStateLog != null ? Content.Task.CurrentStateLog.Exception : string.Empty;
-          this.lastUpdatedTextBox.Text = Content.Task.LastJobDataUpdate.ToString();
+          this.lastUpdatedTextBox.Text = Content.Task.LastTaskDataUpdate.ToString();
         } else {
           this.stateTextBox.Text = string.Empty;
